Attribute VB_Name = "VBgauss"

Public Function GaussDir() As String
    GaussDir = "d:\gauss\"
End Function

Public Sub ExecuteGauss(ByVal GaussProgram As String)
    Dim GaussExe, GaussCmd As String
    
    GaussExe = GaussDir + "gauss.exe"
    GaussCmd = GaussExe + " " + GaussProgram
    
    Shell GaussCmd, vbHide
    
End Sub

Public Sub VBclear(ByVal diskbuffer As String)
    Dim file1, file2 As String
    Dim f1, f2 As Byte
    
    On Error GoTo errMessage
    
    If InStr(1, diskbuffer, ":\", vbTextCompare) = 0 Then
        diskbuffer = CurDir + "\" + diskbuffer
    End If
    
    file1 = diskbuffer + ".inf"
    file2 = diskbuffer + ".asc"
    
    f1 = FreeFile
    
    Open file1 For Output As #f1
    Close #f1
    
    f2 = FreeFile
    Open file2 For Output As #f2
    Close #f2
    
    Exit Sub
    
errMessage:
    MsgBox "error: could not clear the disk buffer"
    Exit Sub
    
End Sub

Public Sub VBput(ByVal diskbuffer As String, ByRef x() As Double, _
                 ByVal name As String)
    Dim file1, file2 As String
    Dim f1, f2 As Byte
    Dim r, c, N As Integer
    Dim i, j As Integer
    
    On Error GoTo errMessage
    
    If InStr(1, diskbuffer, ":\", vbTextCompare) = 0 Then
        diskbuffer = CurDir + "\" + diskbuffer
    End If
    
    file1 = diskbuffer + ".inf"
    file2 = diskbuffer + ".asc"
    
    f1 = FreeFile
    f2 = FreeFile
    
    r = UBound(x, 1)
    c = UBound(x, 2)
    N = r * c
        
    Open file1 For Append As #f1
    Write #f1, name, r, c
    Close #f1
    
    Open file2 For Append As #f2
    For j = 1 To c
        For i = 1 To r
            Write #f2, x(i, j)
        Next i
    Next j
    Close #f2
    
    Exit Sub
    
errMessage:
    MsgBox "error: could not open the disk buffer"
    Exit Sub
    
End Sub

Public Sub VBread(ByVal diskbuffer As String, ByVal name As String, _
                  ByRef x() As Double)
    Dim file1, file2 As String
    Dim f1, f2 As Byte
    Dim name_ As String
    Dim r, c, pos As Integer
    Dim i, j As Integer
    Dim xi As Double
    
    On Error GoTo errMessage
    
    If InStr(1, diskbuffer, ":\", vbTextCompare) = 0 Then
        diskbuffer = CurDir + "\" + diskbuffer
    End If
    
    file1 = diskbuffer + ".inf"
    file2 = diskbuffer + ".asc"
    
    f1 = FreeFile
    f2 = FreeFile
    
    Open file1 For Input As #f1
    
    pos = 0
    
    Do While Not EOF(f1)
    
        Input #f1, name_, r, c
        
        If name_ = name Then
            Exit Do
        End If
        
        pos = pos + r * c
        
    Loop
        
    Close #f1
    
    Open file2 For Input As #f2
    
    For i = 1 To pos
        Input #f2, xi
    Next i
    
    ReDim x(1 To r, 1 To c)
    
    For j = 1 To c
        For i = 1 To r
            Input #f2, x(i, j)
        Next i
    Next j
    
    Close #f2
    
    Exit Sub
    
errMessage:
    MsgBox "error: " + name + " not found"
    Exit Sub
    
End Sub

Public Sub CellsToMatrix(ByVal Sheet As String, _
                         ByVal minX As Integer, _
                         ByVal minY As Integer, _
                         ByVal r As Integer, _
                         ByVal c As Integer, _
                         ByRef x() As Double)
    Dim i, j As Integer
    
    ReDim x(1 To r, 1 To c)
    
    On Error GoTo errMessage
    
    For i = 1 To r
        For j = 1 To c
            x(i, j) = Worksheets(Sheet).Cells(minX + i - 1, minY + j - 1).Value
        Next j
    Next i
    
    Exit Sub
    
errMessage:
    MsgBox "error: CellsToMatrix"
    Exit Sub
    
End Sub

Public Sub MatrixToCells(ByVal Sheet As String, _
                         ByVal minX As Integer, _
                         ByVal minY As Integer, _
                         ByRef x() As Double)
    Dim r, c As Integer
    Dim i, j As Integer
    
    r = UBound(x, 1)
    c = UBound(x, 2)
    
    On Error GoTo errMessage
    
    For i = 1 To r
        For j = 1 To c
            Worksheets(Sheet).Cells(minX + i - 1, minY + j - 1).Value = x(i, j)
        Next j
    Next i
    
    Exit Sub
    
errMessage:
    MsgBox "error: MatrixToCells"
    Exit Sub
    
End Sub


Public Sub ClearCells(ByVal Sheet As String, _
                      ByVal minX As Integer, _
                      ByVal minY As Integer, _
                      ByVal r As Integer, _
                      ByVal c As Integer)
    Dim i, j As Integer
    
    On Error GoTo errMessage
    
    For i = 1 To r
        For j = 1 To c
            Worksheets(Sheet).Cells(minX + i - 1, minY + j - 1).Value = ""
        Next j
    Next i
    
    Exit Sub
    
errMessage:
    MsgBox "error: ClearCells"
    Exit Sub
    
End Sub


