/*
**> pde2d1.prg
**
*/

new;
library PDE2D,pgraph;
PDE2Dset;

a = 0.1; b = 0.05; c = 0.15;

proc aProc(t,x,y);
  retp( a*ones(rows(x),cols(y)) );
endp;

proc bProc(t,x,y);
  retp( b*ones(rows(x),cols(y)) );
endp;

proc cProc(t,x,y);
  retp( c*ones(rows(x),cols(y)) );
endp;

proc dProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc eProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc fProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc gProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc tminBound(t,x,y);
  retp( sin(x+y) );
endp;

proc xminBound(t,x,y);
  retp( exp(-(a+2*b+c)*t)*sin(y) );
endp;

proc xmaxBound(t,x,y);
  retp( exp(-(a+2*b+c)*t)*sin(1+y) );
endp;

proc yminBound(t,x,y);
  retp( exp(-(a+2*b+c)*t)*sin(x) );
endp;

proc ymaxBound(t,x,y);
  retp( exp(-(a+2*b+c)*t)*sin(1+x) );
endp;


call PDE2D(&aProc,&bProc,&cProc,&dProc,&eProc,&fProc,&gProc,0,
               &tminBound,&xminBound,&xmaxBound,&yminBound,&ymaxBound,
               0,0,0,0);

xmin = 0; xmax = 1; Nx = 11;
ymin = 0; ymax = 1; Ny = 21;
tmin = 0; tmax = 5; Nt = 51;

_Hopscotch_PrintIters = 2;
call Hopscotch(tmin,tmax,Nt,xmin,xmax,Nx,ymin,ymax,Ny,"pde2d1");

x = ExtractSolution("pde2d1","x");
y = ExtractSolution("pde2d1","y");
t = ExtractSolution("pde2d1","t");
U = ExtractSolution("pde2d1","t"|tmax);

/* The exact solution is 
**
**          u(t,x,y) = exp(-(a+2b+c)*t)*sin(x+y)
**
*/

proc solutionProc(t,x,y);
  retp( exp(-(a+2*b+c)*t)*sin(x+y) );
endp;

sol = solutionProc(tmax,x,y);


graphset;

  begwind;
  makewind(9,1,0,6.855-1,1);
  makewind(9/2,5.855,0,0,1);
  makewind(9/2,5.855,9/2,0,1);

  setwind(1);
    _pdate = ""; _ptitlht = 1.25; _pnum = 0; _paxes = 0;
    title("Gourlay and McKee @[1977@] - Example 1 page 203");
    draw;

  graphset;
    _pdate = ""; _pnum = 2; _ptitlht = 0.25; _paxht = 0.25; _pnumht = 0.20;
    xlabel("x");
    ylabel("y");
    zlabel("u(5,x,y)");

  setwind(2);
    title("Numerical solution")
    surface(x',y',U');

  setwind(3);
    title("Exact solution")
    surface(x',y',sol');
    graphprt("-c=1 -cf=pde2d1.eps");

  endwind;
