/*
**> pde2d2.prg
*/

new;
library PDE2D,pgraph;
PDE2Dset;

proc aProc(t,x,y);
  retp( ones(rows(x),cols(y)) );
endp;

proc bProc(t,x,y);
  retp( -0.5*ones(rows(x),cols(y)) );
endp;

proc cProc(t,x,y);
  retp( ones(rows(x),cols(y)) );
endp;

proc dProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc eProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc fProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc gProc(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;


proc xminBound(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc xmaxBound(t,x,y);
  retp( ones(rows(x),1) .* (y + y^2) );
endp;

proc yminBound(t,x,y);
  retp( zeros(rows(x),cols(y)) );
endp;

proc ymaxBound(t,x,y);
  retp( ones(rows(x),1) .* (x + x^2) );
endp;


proc InitialGuessSolution(t,x,y);
  retp( rndn(rows(x),cols(y)) );
endp;


proc solutionProc(t,x,y);
  retp( (x^2).*y + x.*(y^2) );
endp;


rndseed 123;

call PDE2D(&aProc,&bProc,&cProc,&dProc,&eProc,&fProc,&gProc,0,
           &InitialGuessSolution,
           &xminBound,&xmaxBound,&yminBound,&ymaxBound,
           0,0,0,0);

xmin = 0; xmax = 1; Nx = 21;
ymin = 0; ymax = 1; Ny = 21;
tmin = 0; tmax = 0.425; Nt = 101;

_Hopscotch_Methods = {2,3}; /* center filling method
                                      &
                               line Hopscotch method */

call Hopscotch(tmin,tmax,Nt,xmin,xmax,Nx,ymin,ymax,Ny,"pde2d2");

x = ExtractSolution("pde2d2","x");
y = ExtractSolution("pde2d2","y");
t = ExtractSolution("pde2d2","t");

sol = solutionProc(tmax,x,y);


graphset;

  begwind;
  window(4,4,0);

  _pdate = ""; _pnum = 0; _paxes = 0; _pframe = 0; _psurf = {0,0};
  _ptitlht = 0.45;    

  i = 1;
  do until i > 14;

    U = ExtractSolution("pde2d2","t"|t[3*i]);

    setwind(i);
      str = ftos(3*i - 1,"iter no %lf",1,0);
      title(str);
      surface(x',y',U');

    i = i + 1;
  endo;

  U = ExtractSolution("pde2d2","t"|t[Nt]);
 
  setwind(15);
    str = ftos(Nt,"iter no %lf",1,0);
    title(str);
    surface(x',y',U');

  setwind(16);
    title("Exact solution")
    surface(x',y',sol');

  graphprt("-c=1 -cf=pde2d2.eps");

  endwind;
