new;
library tsm,optmum,option;
TSMset;

output file = tsm2b.out reset;


@<--- data generation --->@

x0 = 10; a = 0.8; b = 0.1; sigma = 0.06;
t0 = 0; TT = 100; Nobs = 1001;
sv = a|b|sigma;

{t,x} = simulate_OU(x0,a,b,sigma,t0,TT,Nobs,1);


@<--- moments definition --->@

h = 0.1;

proc Moments(theta);
  local a,b,sigma,k1,k2,epsilon,M;

  a = theta[1];
  b = theta[2];
  sigma = theta[3];

  k1 = exp(-a*h);
  k2 = sigma^2*(1-exp(-2*a*h))/(2*a);

  epsilon = x[2:Nobs]-k1.*x[1:Nobs-1]-b*(1-k1);

  M = epsilon~(epsilon^2-k2)~(epsilon.*x[1:Nobs-1]);

  retp(M);
endp;


@<--- GMM estimation --->@

_tsm_parnm = "a"|"b"|"sigma";
sv = a|b|sigma;
_ml_Jacobian_proc = 0;
__title = "Ornstein-Ulhenbeck process";

{theta,stderr,Mcov,Qmin} = gmm(&Moments,sv);

output off;



