new;
library tsm,optmum,pgraph;
TSMset;

_fourier = 1;

rndseed 123456;

Z = eye(2); d = 0|0;
let H[2,2] = 0.2 0 0 0.1;
let T[2,2] = 0.5 0.3 0 -0.5;
c = 0|0; R = 1|1; Q = 0.25;

call SSM_build(Z,d,H,T,c,R,Q,0);
{y,a} = RND_SSM(0|0,100);
y = y - meanc(y)';

{lambda,I} = PDGM2(y);
g = sgf_SSM(lambda);

/* first component */

CV1a = real(inverse_fourier(I[.,1]));
CV1b = real(inverse_fourier(g[.,1]));
covTD = autoc(y[.,1],100);                 /* Autocovariances     */

proc autoc(x,k);
  local t,rho;
  x=packr(x); t=rows(x); 
  rho=rev(conv(x,rev(x),t-k,t));
  retp(rho/t);
endp;

/* second component */

CV2a = real(inverse_fourier(I[.,4]));
CV2b = real(inverse_fourier(g[.,4]));

/* first component/second component */

CV3a = real(inverse_fourier(I[.,3]));
CV3b = real(inverse_fourier(g[.,3]));

/* second component/first component */

CV4a = real(inverse_fourier(I[.,2]));
CV4b = real(inverse_fourier(g[.,2]));


@<--- Plots --->@

graphset;
  begwind;
  window(2,2,1);
    _pdate = ""; _pltype = 6|1|3; _pnum = 2; _pnumht = 0.22; _ptitlht = 0.22; _paxht = 0.22;
    _plegstr = "estimated\000theoretical\000Time domain calculus"; _plegctl = {2 7 3 3};
    xlabel("Lag");

  setwind(1);
    title("cov(y]1[(t),y]1[(t-lag))");
    xy(seqa(0,1,11),CV1a[1:11]~CV1b[1:11]~covTD[1:11]);

    _plegctl = 0;

  setwind(2);
    title("cov(y]2[(t),y]2[(t-lag))");
    xy(seqa(0,1,11),CV2a[1:11]~CV2b[1:11]);

  setwind(3);
    title("cov(y]1[(t),y]2[(t-lag))");
    xy(seqa(0,1,11),CV3a[1:11]~CV3b[1:11]);

  setwind(4);
    title("cov(y]2[(t),y]1[(t-lag))");
    xy(seqa(0,1,11),CV4a[1:11]~CV4b[1:11]);

  graphprt("-c=1 -cf=tsm4e.eps");

  endwind;



