new;
library tsm,optmum,pgraph;

M = 11;
N = 2^M;
t = seqa(0,2/N,N);
chirp = sin(100*pi*t^2);

{H,G,Htilde,Gtilde} = Coiflet(2);

_wcenter = 0;
w = wt(chirp,H,G,0);          /* Wavelet transform */

pkt = wpkt(chirp,H,G,0);      /* Wavelet Packet transform */


graphset;
  call wplot(w,0,1);
  _pnum = 2; _pdate = ""; _ptitlht = 0.20; _paxht = 0.20;
  fonts("simplex simgrma");
  title("Linear chirp --- sin(100\202p\201t[2])\LWavelet Coefficients");
  ylabel("scale");
  xtics(1,N/2,64,0);
  graphprt("-c=1 -cf=tsm5b.eps");
  draw;

graphset;
  _wgrid = 0; _wcolor = seqa(1,1,6);
  call wpkPlot(pkt,1);
  _pnum = 2; _pdate = ""; _ptitlht = 0.20; _paxht = 0.20;
  fonts("simplex simgrma");
  title("Linear chirp --- sin(100\202p\201t[2])"\
        "\LWavelet Packet Coefficients");
  xtics(0,N-1,128,0);
  draw;


M = 6;
Nobs = 2^M;

call varput(0,"Base0");                /* Time domain */
call varput(M*ones(Nobs,1),"Base1");   /* Frequency domain */

call varput(M|seqa(M,-1,M),"Base2");   /* Wavelet transform 
                                          (better frequency localization at 
                                           lower frequencies)
                                       */

call varput(seqa(1,1,M)|M,"Base3");    /* opposite of the wavelet basis
                                          (better frequency localization at 
                                           higher frequencies)
                                        */

call varput(3|1|3|3|3,"Base4");           /* Wavelet packet transform */
call varput(2|3|4|4|2|3|6|6|5|4,"Base5"); /* Wavelet packet transform */


graphset;
  begwind;
  window2(2,3,0,0.5);

  setwind(1);

    _pdate = ""; _pnum = 0; _paxes = 0; _ptitlht = 2.5;
    title("TIME/FREQUENCY representation of basis");
    draw;

    _pnum = 2; _paxes = 1; _ptitlht = 0.20; _pnumht = 0.25; _paxht = 0.25;
    title("");

i = 0;
do until i > 5;

  str = "Base" $+ ftos(i,"%lf",1,0);
  B = varget(str);

  setwind(2 + i);

    call BasisPlot(B,M);
    xlabel("Time localization");
    ylabel("Frequency localization");    
    draw;

  i = i + 1;
endo;

  graphprt("-c=1 -cf=tsm5b2.eps");

  endwind;


