new;

let MU = .1 .2 .3;
let SIGMA[3,3] =  .04  .02 -.01
                  .02  .06  .02
                 -.01  .02  .03;
theta = 1|3|-1;
Portfolio_t0 = 4;

Nobs = 2500;
Portfolio_t1 = rndmn(MU,SIGMA,Nobs)*theta;

deltaP = Portfolio_t1 - Portfolio_t0;

output file = var2.out reset;

e = {0.01, 0.025, 0.05, 0.5, 0.95, 0.975, 0.99};

q = quantile(deltaP,e);
name = "1%" | "2.5%" | "5%" | "Median" | "95%" | "97.5%" | "99%";

print; print;
print "Estimated Quantiles";
print "-----------------";
call printfmt(name~q,0~1);

alpha = 0.05;
VaR = abs(quantile(deltaP,alpha));
print;
print ftos(VaR,"Value at Risk (0.05) = %lf Francs",5,4);

output off;


proc (1) = rndmn(mu,SIGMA,Ns);
  local dim,u,Pchol;
  local oldtrap;

  dim = rows(mu);

  oldtrap = trapchk(1);
  trap 1,1;
  Pchol = chol(SIGMA)';
  trap oldtrap,1;
  if scalerr(Pchol);
    ERRORLOG "error: SIGMA is not a positive definite matrix.";
    retp(error(0));
  endif;

  u = mu + Pchol*rndn(dim,Ns);

  retp(u');
endp;


