new;
library option,pgraph;

S0 = 100; K = 100; sigma = 0.20; tau = 90/365; r = 0.08; b = r;

deltaTau = -7/365;  /* 7 days */

proc muProc(t,S);
  retp( b*S );
endp;

proc sigmaProc(t,S);
  retp( sigma*S );
endp;

C0 = EuropeanBS(S0,K,sigma,tau,b,r);

Ns = 2000;
{t,S} = Simulate_SDE(S0,&muProc,&sigmaProc,0,abs(deltaTau),20,Ns);

S1 = S[20,.]';
C1 = EuropeanBS(S1,K,sigma,tau,b,r);

deltaC = C1 - C0;

alpha = 0.05;

output file = var3.out reset;

/* Long position*/
deltaC = C1 - C0;
VaR = abs(quantile(deltaC,alpha));

print "Long Position";
print "---------------";
print ftos(VaR,"Value at Risk (0.05) = %lf Francs",5,4);
print;

/* Short Position */

deltaC = - (C1 - C0);
alpha = 0.05;
VaR = abs(quantile(deltaC,alpha));

print "Short Position";
print "---------------";
print ftos(VaR,"Value at Risk (0.05) = %lf Francs",5,4);
print;

/* Long Position --- DELTA-GAMMA approach */

deltaS = S1 - S0;
DELTA = EuropeanBS_Delta(S0,K,sigma,tau,b,r);
GAMMA_ = EuropeanBS_Gamma(S0,K,sigma,tau,b,r);
deltaC = deltaS * DELTA + 0.5 * (deltaS^2) * GAMMA_;
VaR = abs(quantile(deltaC,alpha));

print "Long Position --- DELTA-GAMMA approach";
print "--------------------------------------";
print ftos(VaR,"Value at Risk (0.05) = %lf Francs",5,4);

output off;
