new;
library option,tsm,optmum,pgraph;

rndseed 123;

S0 = 100; K = 100; sigma = 0.10; r = 0.08; b = r; N = 4;

deltaTau = -7/365;  /* 7 days */

theta = 6 | -2 ;

/* Call American */
tau1 = 90/365; 

/* Put Look-back */
tau2 = 160/365; 


proc muProc(t,S);
  retp( b*S );
endp;

proc sigmaProc(t,S);
  retp( sigma*S );
endp;

/* t0 */

_type_Option = "call";
Cam = AmericanCRR(S0,K,sigma,tau1,b,r,N);

_type_Option = "put";
PutLookBack = LookBackCRR(S0,sigma,tau2,b,r,N);

Portfolio_t0 = theta[1]*Cam + theta[2]*PutLookBack;

/* t1 */

Ns = 1000;
{t,S} = Simulate_SDE(S0,&muProc,&sigmaProc,0,abs(deltaTau),20,Ns);
S1 = S[20,.]';

_type_Option = "call";
Cam = AmericanCRR(S1,K,sigma,tau1,b,r,N);

_type_Option = "put";
PutLookBack = LookBackCRR(S1,sigma,tau2,b,r,N);

Portfolio_t1 = theta[1]*Cam + theta[2]*PutLookBack;


deltaP = Portfolio_t1 - Portfolio_t0;

{x,d,f,retcode} = Kernel(deltaP);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("\201PDF(\202D\201P)");
  graphprt("-c=1 -cf=var4.eps");
  xy(x,d);

