new;
library option,tsm,optmum,pgraph;

rndseed 123;

S0 = 100; K = 100; sigma = 0.10; r = 0.08; b = r; N = 4;

deltaTau = -7/365;  /* 7 days */

/* Call American */
tau1 = 90/365; 

/* Put Look-back */
tau2 = 120/365; 


proc muProc(t,S);
  retp( b*S );
endp;

proc sigmaProc(t,S);
  retp( sigma*S );
endp;

/* t0 */

_type_Option = "call";
Cam0 = AmericanCRR(S0,K,sigma,tau1,b,r,N);

_type_Option = "put";
PutLookBack0 = LookBackCRR(S0,sigma,tau2,b,r,N);


/* t1 */

Ns = 1000;
{t,S} = Simulate_SDE(S0,&muProc,&sigmaProc,0,abs(deltaTau),20,Ns);
S1 = S[20,.]';

_type_Option = "call";
Cam = AmericanCRR(S1,K,sigma,tau1,b,r,N);

_type_Option = "put";
PutLookBack = LookBackCRR(S1,sigma,tau2,b,r,N);

theta2 = seqa(-10,1,21)';
alpha = 0.10|0.05;
VaR1 = {};
VaR2 = {};

i = -10;
do until i > 10;
  Portfolio_t0 = i*Cam0 + theta2 .* PutLookBack0;
  Portfolio_t1 = i*Cam + theta2 .* PutLookBack;
  deltaP = Portfolio_t1 - Portfolio_t0; 
  VaR = abs(quantile(deltaP,alpha));  
  VaR1 = VaR1 | VaR[1,.];
  VaR2 = VaR2 | VaR[2,.];
  i = i + 1;
endo;


graphset;
  begwind;
  window(2,2,0);
    _pdate = ""; _pnum = 2; _pnumht = 0.25; _paxht = 0.25;

  setwind(1);

    xtics(-10,10,5,0);
    xlabel("Look-Back Put");
    ylabel("American Call");
    surface(theta2,theta2',VaR1);
  setwind(2);
    graphset;
    _paxes = 0; _pframe = 0; _pnum = 0; _ptitlht = 0.50;
    title("\L\L<== VaR at 10%");
    draw;
  setwind(3);
    _paxes = 0; _pframe = 0;
    title("\L\LVaR at 5% ==>");
    draw;
  setwind(4);
    graphset;
    _pnum = 2; _pnumht = 0.25;
    xlabel("Look-Back Put");
    ylabel("American Call");

    surface(theta2,theta2',VaR2);

  graphprt("-c=1 -cf=var5.eps");

  endwind;

