new;
library option;

cnd = ChangeDir("d:\\gauss\\conf3");

tmpfile = "xl3_in.tmp";
load data[] = ^tmpfile;


Smin = data[1];
Smax = data[2];
deltaS = data[3];

K = data[4];
sigma = data[5];
tau = data[6]/365;
b = data[7];
r = data[8];

Nobs = ceil( (Smax-Smin)/deltaS ) + 1;
S = seqa(Smin,deltaS,Nobs);

greeks = zeros(Nobs,5);

greeks[.,1] = S;
greeks[.,2] = EuropeanBS(S,K,sigma,tau,b,r);
greeks[.,3] = EuropeanBS_Delta(S,K,sigma,tau,b,r);
greeks[.,4] = EuropeanBS_Gamma(S,K,sigma,tau,b,r);
greeks[.,5] = EuropeanBS_Vega(S,K,sigma,tau,b,r);

tmpfile = "xl3_out.tmp";

output file = ^tmpfile reset;

screen off;
print Nobs|vec(greeks);
screen on;

output off;

system;

